



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>0327定时执行--存储过程--dbms_job--dbms_scheduler.create_job</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">0327定时执行--存储过程--dbms_job--dbms_scheduler.create_job</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 00:19:23 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<pre class="prettyprint linenums">--oracle job 定时执行 存储过程<br />
--建一张测试表<br />
create table Person(<br />
    name varchar2(50),<br />
    sex varchar2(10)<br />
);<br />
/<br />
--创建测试的存储过程<br />
create or replace job_procedure(pname in varchar2,psex in varchar2) as<br />
begin<br />
    insert into Person values(pname,psex);<br />
end job_procedure;<br />
/<br />
--创建一个job任务<br />
variable jobid number;<br />
begin<br />
    dbms_job.submit(:jobid,'job_procedure',sysdate,'sysdate+1/1440');--每分钟执行一次 24 * 60 = 1440；<br />
end;<br />
/<br />
--运行job<br />
begin<br />
    dbms_job.run(:jobid);<br />
end;<br />
/<br />
--删除job<br />
begin<br />
    dbms_job.remove(:jobid);<br />
end;<br />
/

---------------------------------------------------------------------------

--另一种方法    调度<br />
--建一张测试表<br />
create table Person(<br />
    name varchar2(50),<br />
    sex varchar2(10)<br />
);<br />
/<br />
--创建测试的存储过程<br />
create or replace job_procedure(pname in varchar2,psex in varchar2) as<br />
begin<br />
    insert into Person values(pname,psex);<br />
    submit();--提交<br />
end job_procedure;<br />
/<br />
--创建一个job任务<br />
begin<br />
dbms_scheduler.create_job(<br />
    job_name =&gt; 'jobname',<br />
    job_type =&gt; 'STORED_PROCEDURE',<br />
    job_action =&gt; 'job_procedure',<br />
    start_date =&gt; sysdate,<br />
    repeat_interval =&gt; 'FREQ=DAILY;INTERVAL=2',<br />
    enabled =&gt; TRUE,<br />
    comments =&gt;  'my procedure job !'<br />
);<br />
end;<br />
/<br />
--执行job<br />
begin<br />
    dbms_scheduler.run_job(job_name=&gt;'jobname');<br />
end;<br />
/<br />
--删除job<br />
begin<br />
    dbms_scheduler.dorp_job(job_name=&gt;'jobname');<br />
end;<br />
/<br />
/*<br />
参数说明：<br />
job_name: 顾名思义,每个job都必须有一个的名称<br />
schedule_name: 如果定义了计划，在这里指定计划的名称<br />
job_type: 目前支持三种类型:<br />
 PL/SQL块: PLSQL_BLOCK,<br />
 存储过程: STORED_PROCEDURE<br />
 外部程序: EXECUTABLE (外部程序可以是一个shell脚本,也可以是操作系统级别的指令).<br />
job_action: 根据job_type的不同，job_action有不同的含义.<br />
 如果job_type指定的是存储过程，就需要指定存储过程的名字;<br />
 如果job_type指定的是PL/SQL块，就需要输入完整的PL/SQL代码;<br />
 如果job_type指定的外部程序，就需要输入script的名称或者操作系统的指令名<br />
enabled: 上面已经说过了，指定job创建完毕是否自动激活<br />
comments: 对于job的简单说明

*/<br />
/*<br />
    ----------repeat_interval参数------------<br />
repeat_interval =&gt; 'FREQ=HOURLY; INTERVAL=2'    每隔2小时运行一次job

repeat_interval =&gt; 'FREQ=DAILY'        每天运行一次job

repeat_interval =&amp;gt; 'FREQ=WEEKLY; BYDAY=MON,WED,FRI"    每周的1,3,5运行job

repeat_interval =&gt; 'FREQ=YEARLY; BYMONTH=MAR,JUN,SEP,DEC; BYMONTHDAY=30'    每年的3,6,9,12月的30号运行job

*/<br />--如有错误，欢迎指出！！！</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2jmjo8.html">《A Convolutional Neural Network Cascade for Face Detection》</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd5r0x9.html">此地址使用了一个通常用于网络浏览以外的端口。出于安全原因，Firefox 取消了该请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxexxv8.html">使用 AngularJS 和 Electron 构建桌面应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k24k58.html">GridView控件RowDataBound事件中获取列字段途径</a>
		</li>
						<li><a href="https://www.batexi.com/a/495zogm9.html">TCP Server&mdash;Linux</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvd7wzq.html">超级内存NVDIMM</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv0ddzq.html">SQL Server 的事务和锁（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok6p619.html">&lbrack;HAOI2006&rsqb;聪明的猴子</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kkyy69.html">MySQLHA系列MHA（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kvd0z9.html">C&num;操作WORD换行</a>
		</li>
						<li><a href="https://www.batexi.com/a/8med75oq.html">Lightoj 1004 - Monkey Banana Problem</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojpy65q.html">将数组写入Plist文件中</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvj42r8.html">PhoenixFD插件流体模拟&mdash;&mdash;UI布局【Dynamics】详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/960m2gn9.html">PHP&mdash;&mdash;敏感词过滤</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv5vw28.html">jmeter设置全局变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw4jzx9.html">python将目录切换为脚本所在目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jr500q.html">Disruptor并发框架简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kdmnwq.html">lnmp服务器配置HTTPS</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv1m1gq.html">2012年5月阿里巴巴集团&amp;rdquo&semi;去 IOE&amp;rdquo&semi;运动的思考与总结【转载&plus;整理】</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pjvww8.html">linux添加静态路由</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mnp6gpq.html">大数阶乘&lpar;c语言&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn15zwx8.html">sort&lpar;&rpar;的多种用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv0l2oq.html">修改eclipse中tomcat的发布路径</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mnrokq.html">Base64加密</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdeo2xv9.html">通过Driver获取数据库连接</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmdodl9.html">JVM调优总结 -Xms -Xmx -Xmn -Xss（转载）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4ynlveq.html">锋利的jquery-DOM操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0pwjeq.html">javascript Date 函数的坑</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1od5e9.html">javascript 创建对象及对象原型链属性介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xn5709.html">jQuery实现公告文字左右滚动</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
